<template>
  <div class="app-container">
    <el-card>
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="88px">
        <el-form-item label="设备编号" prop="deviceNum">
          <el-input
            v-model="queryParams.deviceNum"
            placeholder="请输入设备编号"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item label="设备名称" prop="deviceName">
          <el-input
            v-model="queryParams.deviceName"
            placeholder="请输入设备名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="el-icon-plus"
            size="mini"
            @click="handleAdd"
            v-hasPermi="['app:device:add']"
          >新增</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            :disabled="multiple"
            @click="handleDeleteAll"
            v-hasPermi="['app:device:remove']"
          >删除</el-button>
        </el-col>
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>
    </el-card>
    <br>
    <el-card>
      <el-table border stripe  v-loading="loading" ref="multipleTable" :data="disposalList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55"  />
        <!--        <el-table-column label="ID"  prop="id" width="80" />  -->
        <el-table-column label="设备编号"  prop="deviceNum" />
        <el-table-column label="设备名称"  prop="deviceName" />
        <el-table-column label="型号"  prop="model" />
        <el-table-column label="厂家"  prop="manufacturer" />
        <el-table-column label="投入使用日期"  prop="investmentTime" />
        <el-table-column label="设备保养周期(天)"  prop="days" />
        <el-table-column label="联系人"  prop="userName" />
        <el-table-column label="联系电话"  prop="phone" />
        <el-table-column label="操作" width="180"  class-name="small-padding fixed-width">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleView(scope.row)"
            >查看</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['app:device:edit']"
              style="margin-right: 10px"
            >修改</el-button>
            <el-popconfirm
              v-hasPermi="['app:device:remove']"
              :title="'是否确认删除所选数据项？'"
              @confirm="handleDelete(scope.row)"
            >
              <el-button
                size="mini"
                type="text"
                slot="reference"
                icon="el-icon-delete"
              >删除</el-button>
            </el-popconfirm>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
      />
    </el-card>

    <!-- 添加或修改死淘处理方式对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" label-position="left" :model="form" :rules="rules" :disabled="isView" label-width="120px">
        <el-form-item label="设备编号" prop="deviceNum">
          <el-input v-model="form.deviceNum" show-word-limit maxlength="15" placeholder="请输入设备编号" />
        </el-form-item>
        <el-form-item label="设备名称" prop="deviceName">
          <el-input v-model="form.deviceName" show-word-limit maxlength="20" placeholder="请输入设备名称" />
        </el-form-item>
        <el-form-item label="型号" prop="model">
          <el-input v-model="form.model" type="textarea" :autosize="{ minRows: 2 }"   show-word-limit maxlength="30" :placeholder="isView ? '' : '请输入型号'" />
        </el-form-item>
        <el-form-item label="厂家" prop="manufacturer">
          <el-input v-model="form.manufacturer" type="textarea" :autosize="{ minRows: 2 }"   show-word-limit maxlength="30" :placeholder="isView ? '' : '请输入厂家'" />
        </el-form-item>
        <el-form-item label="投入使用日期" prop="investmentTime">
          <el-date-picker
            v-model="form.investmentTime"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择日期">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="设备保养周期" prop="days">
          <el-input v-model.number="form.days" show-word-limit maxlength="3" placeholder="请输入设备保养周期" >
            <template #append>天</template>
          </el-input>
        </el-form-item>
        <el-form-item label="联系人" prop="userName">
          <el-input v-model="form.userName" show-word-limit maxlength="10" :placeholder="isView ? '' : '请输入联系人'" />
        </el-form-item>
        <el-form-item label="联系电话" prop="phone">
          <el-input v-model="form.phone" :placeholder="isView ? '' : '请输入联系电话'" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer" v-if="!isView">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import { getDevicePage, getDeviceDetail, addDevicePage, editDevicePage, delDevicePage } from "../../../api/app/device";
import {changeDate} from "../../../utils";
import {required, rules} from "../../../utils/formRules";

export default {
  name: "",
  data() {
    var validatePhone = (rule, value, callback) => {
      if (value === undefined || value === null || value.trim() === '') {
        callback();
      } else {
        let phoneRegex = /^(?:(?:(?:13[0-9]|14[579]|15[0-3,5-9]|16[6]|17[0135678]|18[0-9]|19[89])\d{8})|(?:0\d{2,3}-\d{7,8})(?:-\d{1,6})?)$/
        if(!phoneRegex.test(value)) {
          callback(new Error('请填写正确格式的联系方式'));
        } else {
          callback()
        }
      }

    };
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 表格数据
      disposalList: [],
      // 弹出层标题
      title: "",
      isView:false,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        deviceName: null,
        deviceNum: null,
      },
      // 表单参数
      form: {
        id: null,
        deviceName: '',
        deviceNum: '',
        investmentTime: changeDate(new Date()),
        manufacturer: '',
        model: '',
        phone: '',
        userName: ''
      },
      rules: {
        deviceNum: [required('设备编号不能为空')],
        deviceName: [required('设备名称不能为空')],
        phone: [{ validator: validatePhone,  trigger: 'blur'}],
        days: [
          required('设备保养周期不能为空'),
          {  pattern: /^(365|3[0-5]\d|[12]\d{2}|[1-9]\d?)$/, message: '正整数，且数值范围（0,365）', trigger: 'blur' }
        ]
      },
    }
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询检验项目列表 */
    getList() {
      this.loading = true;
      getDevicePage(this.queryParams).then(res => {
        res.data.records.forEach(item => {
          item.investmentTime = changeDate(item.investmentTime)
        })
        this.disposalList = res.data.records;
        this.total = res.data.total;
        this.loading = false;
      })
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.isView = false;
      this.title = "添加设备档案";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      let params = {
        id: id
      }
      getDeviceDetail(params).then(res => {
        this.form = res.data;
        this.open = true;
        this.isView = false;
        this.title = "修改设备档案";
      })
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.reset();
      const id = row.id;
      let params = {
        id: id
      }
      getDeviceDetail(params).then(res => {
        this.form = res.data;
        this.open = true;
        this.isView = true;
        this.title = "查看设备档案";
      })
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        deviceName: '',
        deviceNum: '',
        investmentTime: changeDate(new Date()),
        manufacturer: '',
        model: '',
        phone: '',
        days: '',
        userName: ''
      };
      this.resetForm("form");
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            // 编辑
            editDevicePage(this.form).then(res => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            })
          } else {
            // 新增
            addDevicePage(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id;
      let params = {
        ids: ids
      }
      delDevicePage(params).then(res => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      })
    },
    /** 删除按钮操作 */
    handleDeleteAll() {
      const ids = this.ids;
      this.$modal.confirm('是否确认删除所选数据项？').then(() => {
        let params = {
          ids: ids.join(',')
        }
        delDevicePage(params).then(res => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
          this.$refs.multipleTable.clearSelection();
        })
      })
    }
  }
}
</script>

<style scoped lang="scss">

</style>

